unit LazLogo;

{ *************************************************************************** }
{ Copyright (c) 2007 Theo Lustenberger                                        }
{                                                                             }
{ This software is provided "as-is".  This software comes without warranty    }
{ or garantee, explicit or implied.  Use this software at your own risk.      }
{ The author will not be liable for any damage to equipment, data, or         }
{ information that may result while using this software.                      }
{                                                                             }
{ By using this software, you agree to the conditions stated above.           }
{ *************************************************************************** }

//Special Edition fr Das Deutsche Lazarus Forum

{$mode objfpc}{$H+}

interface

uses Classes, Sysutils, Types, Graphics,
{$IFDEF FPC}zstream{$ELSE}ZLib{$ENDIF};

function EncodeFileForUnit(FileName: string): string;
procedure DecodeFileFromUnit(Inp: string; Strm: TMemoryStream);
function WrapForUnit(inp: string): string;
procedure GetLazLogo(Bitmap:TBitmap);

Const CBufferMax = 4096;

Const LazLogoData=
'eJzlmgdUlFfax23YNTawgIIICIogSBEEQht6GREGhgGG3nsbEVBRsWFXxC5GQSwBs9FYk7gmMSYxMZp'+
'sdNVsPPGkGE3/0hP3+83c5d0J6GZzPnP27PmeY8g79733vs/9/5927/v6hhc69NCJC/9Z898q/pvAfz1'+
'7jNG1z+T+iCE9ergN6SHJ33XS2Ng4ZIhe6/9L6dWrV58+ffr27Ttw4MChQ4caGhqOGzfOzMzM0tLSxsb'+
'G1tZ22rRp/J06derkyZMnTpw4ZsyY4cOH09nAwKB37949e/Z8hMpAB6T8vVPq6+sf4eT/jSKxM2DAAMA'+
'ZOXIk+MMOXECKg4ODi4uLq6vrzJkz+evk5GRvb8+t8ePHwyP9+/Xrx/BHy5EQqIGgCxcuYAOPfPL/FgF'+
'Ylo8j9O/ff/DgwfjF6NGjAd/CwgJ/EexAjbtO3Nzc+Ono6IhDWVlZ0Q02GQVHj9yPhDAtBAUEBEgtBgM'+
'GGVnb6//r2euf9A0yHPvAW8PNLPXbBwwfNWy8Oe1j7V0dE/JmqAvNPAJ69THorsBjxmZ2MWlOyUVT5Yl'+
'Dx5mKxmGmFtJUI8ytpc7/fISN9u9go3HStX67+NdvyGMPW3XPTsF3QAD7B2ER3EaNGgXskyZNmjJlCuz'+
'gMrNmzfL09PTw8IAg2JkxYwYeBHdEP1NTU9h87LHHcL0/ItZJAkGoKinff+iwaVFJCW3n5r7795Sn37C'+
'VJxgMGCg9GsQ8ixeVXP4q/cRfwLZP/4Gi3cTJ0z2vRnPjF0aFrmweZWGTf/6DtGeu5L102yW1xEomd80'+
'oV3e8ah0co/9on6pVldd/zj77N4+iOpe0srBVT0SubxsyxmS8s1dQ/TZuKXYdnxwULcBErIOjQ1fs4hG'+
'Vf/3Js7huzJTpDnEZ6SfeFqrOzKjgWbSrO16hxbtyea9O6d0pfTrFQCdENnxHsDNixIi5c+euWbNm48a'+
'NTU1N27Zt27lz5+7du5cuXRocHNzW1nbq1Kn58+cHBQX96U9/Iv4kJyevWLGCu0uWLFm0aBFj0TM1NfX'+
'w4cPcNTIyamhoYLixsfGCTvHz8xML59H0OXDgQGRkJJZQWFioVCrxysDAwNU6SUlJ0QdKECSisQjIqG1'+
'i58Qy5Rva+MmEtNNBYgrvUO57TqJVgNBv4CA4Knr9HsOxK8XOY6VvfW1kbsVPrJRJhhmblrz5pV1Mqhg'+
'4I6mAR6Qeu2wwcLCkDK4Us+PYcDMrrh1Uub5Vq4RiDGcSpp3k4c+ouOaTg3VCIrALj6UloGataBmEDB4'+
'c1Xg4+7mb/TpFqITobmpHDdXJsGHDoAbfIfXgPrjG0aNHv/vuO5VKFRoaCuAXL1585513Wltb33///ZC'+
'QkLi4uMuXL1+6dIkh2PaPP/4YERFBrAPemzdvgjaJY/bs2fiXyPVESxaC03HNWGmZBQUFd+/eJc3hmyd'+
'Pnvz00095tEKhOHfuHJG2hy4HVVRU6NOk7+/oj/OiefHr9woufMhCWBdr1GcKccuttglV6AM4froLWCW'+
'0/ZmF8yC/8vo5mw4wDz+ZBGSASL7hQMmbX/QdoPW+jNPX6N/Fs5B+Q4ZFrG0V1M9uPGxkOUVgyyRMOyu'+
'9lFHBC9aN6RRTK2tsI6X9gviJAQPgKKPR6kMvmTt7MIrlCC4Ak/xOn7Fjx2LeJiYm8EJVYG5uDsgEt+n'+
'Tpzc3N9+5c8fX11cmk8ECuN24cWP//v1kBFEh4BqnT58Wy8GPrl+/Dmhou2zZMiIhXPAUVuHl5cU1j+a'+
'aeMg1YVNa4/bt23FGca3RaK5evcoFPoUaohFXOnbsmD4sgMwTWY4oZtAES1DtfgY0rJzdWRfgwB19cCs'+
'pWERvfWpKSMzUkBjbMIVdRFxQ7Vr6Ry7fLobPCIr0UueBAD8pX4EOlOKaT9DH3MOf4SIwDjedJKnRJUf'+
'wrBHGExQ7jk6PjJ8RleiqSHZXpifs0c7gl1U2VSe2Osk5fbXy2o+20x0oj0ES6wX2iZZWphaW+lyQZbg'+
'LFwwhp2D2pH4qNLClEiDvPP744y0tLZ988olMJz4+PqQhvIn2s2fPErtY19atW7F8YbFoiFtt2rRJWsL'+
'ChQuPHDmCGgz8FxxBdEdHRxeOEPoTM69cufLLL78kJSXpcyQIgguWw0J4BEVLmKYeNCIWrJvuG2zt6mG'+
'k2wgIt6I/xjPOxi77+ZueOXO9cqt8CmpSOy5oY05hNdAxHBAwS/4CCMjYODqHL27U3LzPvwnTnZmh7C/'+
'f0t/QckqfX4sU1rAK7N9ZkZL21MWA0rqQyvrwquVFFz7UchSjAlJw8NJJ0uYD2jyYUUjoEIUx+PNcFmJ'+
'tbS32NXZ2djACHQxkCPiTHQQXZAGyTLBOyBGCI29vb2ZjHjiFcVyPdRUXFxP9Tpw4IUV+piU20l8Ck5g'+
'TFRVFLvu9HMH4tWvXiHubN29G1S7hBTQgCGPD10BVLESmSGDhJa99krD9SOKeE0Wv3lE1H5/i4csTjXT'+
'ChU9+tYc6l60c4TTloLbM8ItTU6aKWggo+OuvSEjeexI7527F1e9lpXUMxGGT27WZ3V6ugvSBnUIMEWl'+
'CeDQ2Az5xTYfcgiOcnZ2ZtvzKV5V//TEoRCukjLCwsPDwcOXcxdqyobEVkIGLSIXl0xlYxKYGtCEU2Ll'+
'LH4YQWEByjk64IImQWZhNcITmDBQ7oAkTJsAg6YMlA+OOHTvwFEBLTEzkFhdY/u3btwUdgEx45AIDuH/'+
'/PpYmccTTmS0rK+thHGFO33zzDXGaa7hAT32OcBBiAjijFV7PbIRiFCu//EXp63dZHQo7ubknt5ypvPa'+
'Db1qRpU54ItMmPXHSxdsP0y25+Anhyz8oBByEWQKjorRGc/0nLdcX78au3OHqI8MscVWChn9pHe1R61v'+
'RaqROuBD5AmrE1l4UwO7evhmHzvn6+YXHac2m+IX3ADYmJgY0YnWiVKdqy5Vnr9Iu0ObReAea+Pv7C08'+
'R1Mjl8ujoaO0QpVKlk/j4eH4ykFH0oTwgH7EcXI+YiSaohJ3cunUL3uH6o48+SktLA7S8vDxShlqtJhh'+
'+9tlne/fuFeCTmBjY3t5O2hJ5JDMzE47wrCeffJLJWRpVh+AI+g4ePCg4wjfPnz+PDkShZ599VnAtCWr'+
'gC2iFCxAE6CbMLLfjvLa6U6dDGcbpLQssu/JlxV++9QoKFTtudPaXR6fvOxUkjyKIlVz4kJWCkoRh/lN'+
'aZ8luPR0eKQco2Me8w8vrMAZ7J5eS1++Vv/0/1vaOqA1rUvomqqQe+LNwZ/Th6XGVC9I27k2qWcpsBe0'+
'vJiQkYMZJelL20i3NX39KTEkFdiooHi05iPAX9KEdRhgIsCk6oX7mJ+10Y9WoR83w8ccfowM+Is55cG3'+
'CF6GGGXJycliyAA2jstcT0BPt6Ax9PJSIzU/CAjYAj7ghpktgwQtQQOxJMQaUZ2YpTmJC6enpODKM6HO'+
'EMhgtFssMIAnO9ETzjHXazUjKiiYpFOR0vEyLalljoE6EvyQuWZ/d9hzt+U9dABwGAlSiTvLbztCeXKK'+
'hUdhqaOTsine+e9zHB1WDc8qw//imQ+IQjL+kMNT28PHV3Pg5MEzrDlgLAxme13qq8Cnt0/O2HUzVSZq'+
'eFO4/xa2sRQ20gzwgCAUSdCKuBTViYLpOuKYdnVkaxoBVUHF9+OGHFDlQALxSmSRtIf9TQkIkcLGDhj5'+
'gBxbBUVJxpRb59he5xhhYS9Fp7YYxbe1OYaKS5B+9SHvm1kOSrQIUCGRqajTXfshr3Csslgijnr+CnjE'+
'FFVBM0FbMbyAYxixcM0snKIDDKiq1YVBVMZ8nitnANi07t+KNe1qOlq8nemT9WvJXbeZW0d5j3MrQCRR'+
'IDApGaNQfyLXgCBvAqrEZnkWdRg2AnniQOIJ72OlBz969e7FbMTEbNMG8ty7v/KEi+REoEcCxXuK2Mq8'+
'0c4u2Xip/8/O0FZvTG7bkP/mCFofjl5SJaijDQ0X81wbGBHXFla8SF6ykhVv4kQjUwJK7eFXFxU8Knzi'+
'avWhlzrqdFZe/KL/0WWbTflgWvjknp7jwuWs57edjSuZFqpLjNXVlb9yjT/aWtn+wk5Ym4M2rX625+Ut'+
'2mSb715I3v770mNZIKt/6urCpJUdTk/VwEUMkjvAy9McwMFGUxzhJW9gPHHXZuetLr779xs/0tZapAyu'+
'aVMtbjexcexn07WnQ94/jiGRNLiBBoyfxVtQ/EYmpMYWViiJNXEmVsrQ6oaI2SbNAlZWn1An+AkfgzIo'+
'Id9hhmCo5OEIOvyJUQhO+g/VqccnJxc6Lmo8U7mrPrK1PSc9ILdGAv8gdwkkTiysz1jdnbTuU1diSWlG'+
'TjNWXV8GOZPn/oGPB0uxukju3Nm/JaulfbtX87n26iOAIA2AtLIF6gJxCNsRcqSpFDpI2g+JASWCF+ww'+
'cO2GMvY9vymI7ecooe5eh5lZ9hz70bPBRCTZDBJYOEgnLolhFc/giIkGBlBpEMSCSMu5Gu9hNSJ2JltB'+
'EB1jQhjsdyAIWgQxOAfgip4jELTIIIiKkSBl002cn55FKd45IhaKQw2LFThCm2A6QkrRBz8CAfXX/EaP'+
'GOQdYeCT4qGvGOc82+OOpkUS8LpFeZlFRi00fakMZGxNKOMoJgT/RSVR9opDAiQgU5BHiJMzyF6boxl3'+
'COyAIqLvYsMSXlD4kEY3do1N3UWdmRqakxWekZ+j1ERTwv/TcPHV+YVJ+YWpefneCpVinVCUEz1HMCot'+
'y8Auxdve2dPUwd3A2tbUzNjUbjVNNshpr52w01cXYWWbqFe0wu2RaQP5kr4QJM4MHjjXujmRVVZV0gkq'+
'Kl9rBUGrHdLsPBOFNmzZRnK9YsUJ/oCRiUz9ixAjqQ/RiryTOcyj/cH/BGkUXFZeIhLgV+0eRTaADjkR'+
'J6aITaIJNjJMIRmEpxavu0eaBktkpXa67dwtJy5zsn2M3R+OeWBKZks5jIDg9Oys2M0emzrUPT5/oHmv'+
'iJDebJQ9Oy8vIzZOY4oIZicKK7AIvVZ5tQLKpu8LUZY65m9LMNdpsZqyNT6KNr9LaO9hwiu+Q8d6GNkE'+
'eSk1A+tLYuY1WfrGj7Z179+//QGsnJLJR+uqrr7D2LreAiF1ScXFx91ELFy784YcfKioqQN7Gxmbbtm1'+
'Epy59xIEqTIltvv4hJAJxFH7sFwgF+Bc5S7AgCm9RnuFH4vUKBsPWCR65RVbqEu4eRpPwJlF9iUos9dd'+
'SWlra1tYGvFKLMlntpsy1Dsyw9M9IaXgybN4Tlo+rbAMSPOJK4mp2KefvSdt0XJazzi1+iWf6+lFWYRN'+
'dI/yTc2MLilMKClMKilQlmpDC+Z7qWkufFCvvVLuwPMeQ/GmyzFlRpV5KjZtyXkL1Tq/ExfZhhXayrMD'+
'8jRazkk3swibOCuz3W58TsIe9fft293bwhyNCUJd2YLx//35hYaF+4549ewb8ulaUjjHFKxVxmK9/ni8'+
'dt+JceCIBUBxHwA51YJezF9xWcETComoS1d3Dwp2gRkpM+J3+vkacAyAs4emnnz5z5kx8p8zJyXWPKfZ'+
'Ka3CIWeCZsVq5+lhI7QH/0j1OiSt9cjYkrD4WuXBf/tZnnVTLYqqbg4u3jrKJHGziPsLCc7xjiENwqr0'+
'sRVW7e8aceR6qhfKKXbHzdocWbZZlrHFXzvfPXBGYtcolSjMzti66dl/WplNzap5wlpdPcAwztLb5zRf'+
'i+hyxGcfU/zVHJ06cuHfvHtPqN4L2A3dk0rGzECAi4onCRnpNiRM1NDQQM6koCH0wtWjRIoDFj9atW0f'+
'0Eyd11dXVBw8e3LJlC7ADfmtrq0QKjvzMM8/s2rVLpAMcvL29ff369XQWO25Rz9NSVlaG79TU1IR3yhd'+
'ffMFdcUYnCw1xDw53Do6WqYvDc6rK1rfEV2+Tl6zzTMgJS1CHp+bIC+fNaz7lU7Bdlr06vr7NRVE3xNh'+
'jsLHbMHNvIyuZuXuyQ0ydf/Ya/6zVUXP3zNbsCixs9Ehc5q1eHpq/MaRwc1TldseIqgku6SGFO9zil7p'+
'EVU+aFTl01KjfxVFzczM06XNErKOAFO8vhLCoLq8h/n05fvy4OKqVXvcTY2/evIlJ19XVXbt2TbzrxwZ'+
'2796NN33//fdkPTxo8+bNb7zxxvLly3n0hQsXQP7jjz8WW0jm5FZjY+OLL754+vRpKPvggw9gp6Oj49t'+
'vv8UqxKEo7nnlypXz58+TYd966y0SMbzDKY/AJDx1glU8rhPhzj5+/kHKlICMWkVFg/ecRIUyHvNIK6+'+
'q2nHGMqDSP29D3OLDJg7xIy2CRliGjJgoi9LsVC5qVS7YJ6/eFz63Jaq6JX5Ju2/mpqmBlZbeuS6KRW6'+
'qla5xC61lpf5ZTTOVy10jNOOdvYcZGw8aM3bASMNBY417PuQLEDj68ssv0fzQoUOQ0oWjHTt2YMCAwJK'+
'Fi/3888/79u37P3IkBM8iRtXW1ooXGVQgeA2OwPyvvvpqQUEBsejNN9/08fF59913wYddDyELQolXcCT'+
'q6rt37+bn54vswwXOgqdQflCE3Lp1izggfTPAKvAmaksKSEIcebClpWXVqlWQK94ZUcNwV7wGEh7tAXP'+
'BkfE1Tcra7aFpZeHRsXJlwpK9xyOr9nqmb4he0OYUvcTUPXuMbbSxXXzM/P2zq/dGLXo6ovZIgOaAv+Z'+
'w2KKj8etOK1ediVp4JKBsn7LhjGLFMUfVev/s7e6KBVazUkZNltl4q2yDS8c4qIeO9+w/3PBhHEl+tHP'+
'nzi4ciVhHXMLaCSBcv//++939iH3Qv8nR/v37165dS3AjttBSVFQEF+KFIPYAhgQx/kINsaukpOS1115'+
'DBx5648YNdICszz//nOh0584dajxYo+D5m0649d5778FRU1MTHgHCV69exR0Anz0aKY+pCKdUlQRPeOH'+
'i+vXr1Jm4FQzi0RN1IspO/c+rnGd5Bqdp0lceTFm8PSI1X6YumLvnVPbm42Hzn/Qp2uOUvG2yrGZKYJW'+
'7ejHVhSyp1C8+zy++wE9Z4JdQHJhR45+zKnBee+TKF9Tb3/KpOelRdDB66XHP9HUTnFRjpsXIMtdEFmw'+
'aOTl9mFlcv6FjfpMjCi3xoVGPbvmI8o9ajguC/0cffdQlfgJ+l2kfGGDpRh1FMAFkUMIpHB0dgY5tFDY'+
'MCyhAxDM0NMRaPv30U/AhT6Hh4cOHFy9eTMjCqc+dO0f4+uabb3AoyrwXXniB/EIlQySkG6y9/fbbcET'+
'O+umnn6gJqUnEe1uC5NatW+Fiw4YNTEuRgFWwu6RMnTdvnmGnjB49WmwWUAa+2CPgXDOcnF1DosPLNhZ'+
'teWbuzmPpy1uSlh3yytvlRPiS58vkcVGK2AS9I1ZRsYhjWGV8fEBkTET5Zo/SDruUFq+Kk2557RNDVrm'+
'kbPfI3RVa+5RPUavtnLUT3NMf+JlTj251HSYk/KULRyyQOM8Fan/99dfS0TcCdJcvX+5CEEQ8kCMp1lG'+
'uE2q4ILm8/PLLZ8+exeZBg8SEncjlcioEgMXySS7YOT+hjxkYSAQiMr/00kuQAl/4NbdooRv6V1ZWXrp'+
'0iVs4I1sDkilWR/FPMlq6dCm3MADiNnQzORUmQzZu3Di4U8TXI+KdIHsEdIBl+kxlDz7DyUEW4RGbFZR'+
'Z6R6b4xYaLQsNi5TLpfcUSiWExKs6hWsaMSRiuK8swCUwaqp/snVQ+RTFOq+yjojlf1asPSevPeyU2OA'+
'wp3LIaLMHEsRiX3nlFUJ6pE54EEZIFkCx8vJyOGJRwAVK5HHpLR6FMVECC2EVcAE+MKg/LY3PP/98d1c'+
'CYWZjyVZWVsQ0EncXZvU/7AQugJU+sME2iD+EYumwApHem4t3fKgtXsiKj1IgEa9hKvEdEZ5rYmJi8Fs'+
'i7RS67BHEF4xTpk61177scHZzcxfvx6X3jxSHcAGM8k4RW3JuUf/QGae2nWZrbmEB60YTLcZOmW4yzXn'+
'Y+El9Bw9l6Q8kCBEHaF2EVROW9Vsw/v6/3gWjPOmAEIE7Y5P6Rw1ADUHwq9FoujyO8qBDJ7gqAQpAuqs'+
'kMSWSlGBKes0t3tlZdArXUEM7d2ETavACSnpxekmIQDfxLgCpr6+nQy890d8X6Iv04Zz40FTsEdBB7Lu'+
'xB3G0hangudLnJRi8qAl9OoVrcaJFHywKp0Zh8SJJfG/zn3qLBDX6n3yLV4e/V/SZAiXpOyvxrZT48gH'+
'hWvIacVYpDpZB+GGvAH6vGtJHaJJPiUMScbQF5lBGWNB+A2NjIz4QkgSvF58V0QfrIn0wFm3Fp2v/EYJ'+
'YiPjYG/lfNAHlbA==';


implementation


//from Synapse synacode
const
  TableBase64 =
    'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=';

  ReTablebase64 =
    #$40 + #$40 + #$40 + #$40 + #$40 + #$40 + #$40 + #$40 + #$40 + #$40 + #$3E + #$40
    + #$40 + #$40 + #$3F + #$34 + #$35 + #$36 + #$37 + #$38 + #$39 + #$3A + #$3B + #$3C
    + #$3D + #$40 + #$40 + #$40 + #$40 + #$40 + #$40 + #$40 + #$00 + #$01 + #$02 + #$03
    + #$04 + #$05 + #$06 + #$07 + #$08 + #$09 + #$0A + #$0B + #$0C + #$0D + #$0E + #$0F
    + #$10 + #$11 + #$12 + #$13 + #$14 + #$15 + #$16 + #$17 + #$18 + #$19 + #$40 + #$40
    + #$40 + #$40 + #$40 + #$40 + #$1A + #$1B + #$1C + #$1D + #$1E + #$1F + #$20 + #$21
    + #$22 + #$23 + #$24 + #$25 + #$26 + #$27 + #$28 + #$29 + #$2A + #$2B + #$2C + #$2D
    + #$2E + #$2F + #$30 + #$31 + #$32 + #$33 + #$40 + #$40 + #$40 + #$40 + #$40 + #$40;



{==============================================================================}

function Decode4to3Ex(const Value, Table: AnsiString): AnsiString;
var
  x, y, lv: Integer;
  d: integer;
  dl: integer;
  c: byte;
  p: integer;
begin
  lv := Length(Value);
  SetLength(Result, lv);
  x := 1;
  dl := 4;
  d := 0;
  p := 1;
  while x <= lv do
  begin
    y := Ord(Value[x]);
    if y in [33..127] then
      c := Ord(Table[y - 32])
    else
      c := 64;
    Inc(x);
    if c > 63 then
      continue;
    d := (d shl 6) or c;
    dec(dl);
    if dl <> 0 then
      continue;
    Result[p] := AnsiChar((d shr 16) and $FF);
    inc(p);
    Result[p] := AnsiChar((d shr 8) and $FF);
    inc(p);
    Result[p] := AnsiChar(d and $FF);
    inc(p);
    d := 0;
    dl := 4;
  end;
  case dl of
    1:
      begin
        d := d shr 2;
        Result[p] := AnsiChar((d shr 8) and $FF);
        inc(p);
        Result[p] := AnsiChar(d and $FF);
        inc(p);
      end;
    2:
      begin
        d := d shr 4;
        Result[p] := AnsiChar(d and $FF);
        inc(p);
      end;
  end;
  SetLength(Result, p - 1);
end;

{==============================================================================}

function Encode3to4(const Value, Table: AnsiString): AnsiString;
var
  c: Byte;
  n, l: Integer;
  Count: Integer;
  DOut: array[0..3] of Byte;
begin
  setlength(Result, ((Length(Value) + 2) div 3) * 4);
  l := 1;
  Count := 1;
  while Count <= Length(Value) do
  begin
    c := Ord(Value[Count]);
    Inc(Count);
    DOut[0] := (c and $FC) shr 2;
    DOut[1] := (c and $03) shl 4;
    if Count <= Length(Value) then
    begin
      c := Ord(Value[Count]);
      Inc(Count);
      DOut[1] := DOut[1] + (c and $F0) shr 4;
      DOut[2] := (c and $0F) shl 2;
      if Count <= Length(Value) then
      begin
        c := Ord(Value[Count]);
        Inc(Count);
        DOut[2] := DOut[2] + (c and $C0) shr 6;
        DOut[3] := (c and $3F);
      end
      else
      begin
        DOut[3] := $40;
      end;
    end
    else
    begin
      DOut[2] := $40;
      DOut[3] := $40;
    end;
    for n := 0 to 3 do
    begin
      if (DOut[n] + 1) <= Length(Table) then
      begin
        Result[l] := Table[DOut[n] + 1];
        Inc(l);
      end;
    end;
  end;
  SetLength(Result, l - 1);
end;

{==============================================================================}

function DecodeBase64(const Value: AnsiString): AnsiString;
begin
  Result := Decode4to3Ex(Value, ReTableBase64);
end;

{==============================================================================}

function EncodeBase64(const Value: AnsiString): AnsiString;
begin
  Result := Encode3to4(Value, TableBase64);
end;

{==============================================================================}


procedure SaveToCompressedStream(InStream, OutStream: TStream);
var
  TCS: TCompressionStream;
begin
  OutStream.Size := 0;
  OutStream.Position := 0;
  InStream.Position := 0;
  TCS := TCompressionStream.Create(clDefault, OutStream);
  try
    TCS.CopyFrom(InStream, 0)
  finally
    TCS.Free;
  end;
  OutStream.Position := 0;
end;

{==============================================================================}

procedure LoadFromCompressedStream(InStream, OutStream: TStream);
var
  TCS: TDecompressionStream;
  RC: Word;
  TB: array[0..CBufferMax - 1] of Byte;
begin
  OutStream.Size := 0;
  OutStream.Position := 0;
  InStream.Position := 0;
  TCS := TDecompressionStream.Create(InStream);
  try
    TCS.Position := 0;
    repeat
      RC := TCS.Read(TB, CBufferMax);
      OutStream.Write(TB, RC);
    until (RC < CBufferMax);
  finally
    TCS.Free;
  end;
  OutStream.Position := 0;
end;

{==============================================================================}

function WrapForUnit(inp: string): string;
var i: integer;
const LL = 80;
begin
  Result := 'Const TestC=';
  for i := 0 to (Length(inp) div LL) do
    Result := Result + '''' + Copy(inp, i * LL, LL - byte(i = 0)) + '''+'#13#10;
  Result[length(Result) - 2] := ';';
end;

{==============================================================================}

function EncodeFileForUnit(FileName: string): string;
var Strm, OutStrm: TMemoryStream;
  Str: string;
begin
  Strm := TMemoryStream.Create;
  Strm.LoadFromFile(FileName);
  OutStrm := TMemoryStream.Create;
  SaveToCompressedStream(Strm, OutStrm);
  Strm.free;
  OutStrm.Position := 0;
  SetLength(Str, OutStrm.size);
  Move(OutStrm.memory^, Str[1], OutStrm.size);
  Result := WrapForUnit(EncodeBase64(Str));
  OutStrm.free;
end;

{==============================================================================}

procedure DecodeFileFromUnit(Inp: string; Strm: TMemoryStream);
var tmp: string;
var InStrm: TMemoryStream;
begin
  InStrm:=TMemoryStream.Create;
  tmp := DecodeBase64(Inp);
  InStrm.Clear;
  InStrm.SetSize(Length(tmp) + 1);
  InStrm.Position := 0;
  Move(tmp[1], InStrm.memory^, InStrm.size);
  LoadFromCompressedStream(InStrm,Strm);
  InStrm.free;
  Strm.Position := 0;
end;

{==============================================================================}

procedure GetLazLogo(Bitmap:TBitmap);
var Strm:TMemoryStream;
begin
  Strm:=TMemoryStream.create;
  DecodeFileFromUnit(LazLogoData,Strm);
  Bitmap.LoadFromStream(Strm);
  Strm.free;
end;

{==============================================================================}


end.
